xref: /haiku/configure (revision aa2e5eca78d747234a7557c86d4f104a8301d88a)
152a38012Sejakowatz#!/bin/sh
252a38012Sejakowatz#
3338b8dc3SIngo Weinhold# configure [ <options> ]
4614026d7Sshatty
539d444a3SArvind S Raj# set flag to exit script when exit command is executed
639d444a3SArvind S Rajset -e
739d444a3SArvind S Raj
8022fa244SIngo Weinhold# usage
9022fa244SIngo Weinhold#
10022fa244SIngo Weinhold# Prints usage.
11022fa244SIngo Weinhold#
12022fa244SIngo Weinholdusage()
13022fa244SIngo Weinhold{
14022fa244SIngo Weinhold	cat << EOF
15022fa244SIngo Weinhold
16022fa244SIngo WeinholdUsage: $0 <options>
17022fa244SIngo Weinholdoptions:
18e173a1ecSIngo Weinhold  --bootstrap <haikuporter> <HaikuPorts cross repo> <HaikuPorts repo>
19e173a1ecSIngo Weinhold                              Prepare for a bootstrap build. No pre-built
20e173a1ecSIngo Weinhold                              packages will be used, instead they will be built
21e173a1ecSIngo Weinhold                              from the sources (in several phases).
22e173a1ecSIngo Weinhold                              <haikuporter> is the path to the haikuporter tool
23e173a1ecSIngo Weinhold                              suitable for the host platform.
24e173a1ecSIngo Weinhold                              <HaikuPorts cross repo> is the path to a checked
25e173a1ecSIngo Weinhold                              out HaikuPorts cross-compilation repository.
26e173a1ecSIngo Weinhold                              <HaikuPorts repo> is the path to a checked out
27e173a1ecSIngo Weinhold                              HaikuPorts repository.
28c0e8cc1aSIngo Weinhold  --build-cross-tools <arch> [ <build tools dir> ]
29338b8dc3SIngo Weinhold                              Assume cross compilation. <build tools dir>
30338b8dc3SIngo Weinhold                              defines the location of the build tools sources.
31338b8dc3SIngo Weinhold                              They will be compiled and placed in the output
32a5b60fa8SOliver Tappe                              directory under "cross-tools". The HAIKU_* tools
33a5b60fa8SOliver Tappe                              variables will be set accordingly.
3420ab75e6SIngo Weinhold                              <arch> specifies the target architecture, either
351b38c341SAlexander von Gluck IV                              "x86_gcc2", "x86", "x86_64", "ppc", "m68k", "arm"
36c0e8cc1aSIngo Weinhold                              This option and --cross-tools-prefix can be
37c0e8cc1aSIngo Weinhold                              specified multiple times. The first cross tools
38c0e8cc1aSIngo Weinhold                              specify the primary tools, the subsequent ones the
39c0e8cc1aSIngo Weinhold                              secondary tools (for "hybrid" images).
40c0e8cc1aSIngo Weinhold                              For the first --build-cross-tools the
41c0e8cc1aSIngo Weinhold                              <build tools dir> argument must be specified and
42c0e8cc1aSIngo Weinhold                              for the subsequent ones it must be omitted.
43eccc7665SIngo Weinhold  --cross-tools-prefix <prefix>
44eccc7665SIngo Weinhold                              Assume cross compilation. <prefix> should be a
45eccc7665SIngo Weinhold                              path to the directory where the cross
46eccc7665SIngo Weinhold                              compilation tools are located, plus the platform
470da9c208SIngo Weinhold                              prefix, e.g. "/path/to/tools/i586-pc-haiku-".
48eccc7665SIngo Weinhold                              This overrides the HAIKU_* tool variables.
49a66c32ddSIngo Weinhold  --distro-compatibility <level>
50a66c32ddSIngo Weinhold                              The distribution's level of compatibility with
51a66c32ddSIngo Weinhold                              the official Haiku distribution. The generated
52a66c32ddSIngo Weinhold                              files will contain the respective trademarks
53a66c32ddSIngo Weinhold                              accordingly.
54a66c32ddSIngo Weinhold                              official -- the official Haiku distribution.
55a66c32ddSIngo Weinhold                              compatible -- a Haiku Compatible (tm) distro.
56a66c32ddSIngo Weinhold                              default -- any other distro (default value).
5760d8d8fcSIngo Weinhold  --enable-multiuser          Enable experimental multiuser support.
58eccc7665SIngo Weinhold  --help                      Prints out this help.
592ebcd86dSIngo Weinhold  --host-only                 Configure for building tools for the build host
602ebcd86dSIngo Weinhold                              only. Haiku cannot be built when configured like
612ebcd86dSIngo Weinhold                              this.
62eccc7665SIngo Weinhold  --include-gpl-addons        Include GPL licensed add-ons.
6367838392SAxel Dörfler  --include-patented-code     Enable code that is known to implemented patented
6467838392SAxel Dörfler                              ideas and techniques. If this option is not
6567838392SAxel Dörfler                              specified, the resulting distribution may still
6667838392SAxel Dörfler                              implement patented ideas and techniques. This
6767838392SAxel Dörfler                              option only disables code that is currently known
6867838392SAxel Dörfler                              to be problematic.
6976fa0be3SIngo Weinhold  --include-sources           Includes the source code of projects that require
7076fa0be3SIngo Weinhold                              either an offer of source code or a copy of the
7176fa0be3SIngo Weinhold                              patched sources. This is preferable when
7276fa0be3SIngo Weinhold                              distributing on physical mediums.
731974210fSFrançois Revol  --include-3rdparty          Include 3rdparty/ in the build system.
7460d8d8fcSIngo Weinhold  -j<n>                       Only relevant for --build-cross-tools and
7560d8d8fcSIngo Weinhold                              --build-cross-tools-gcc4. Is passed on to the
7660d8d8fcSIngo Weinhold                              make building the build tools.
77*aa2e5ecaSOliver Tappe  --no-downloads              Do not download anything. Useful when trying to
78*aa2e5ecaSOliver Tappe                              bootstrap and build Haiku from source only.
7986d7e283SOliver Tappe  --remote-user <username>    Use given username when logging into
8086d7e283SOliver Tappe                              git.haiku-os.org (via ssh).
817c4641d0SOliver Tappe  --target=TARGET             Select build target platform.
827c4641d0SOliver Tappe                              [default=${TARGET_PLATFORM}]
83a17b9c0cSshatty                              valid targets=r5,bone,dano,haiku
84483b28e4SIngo Weinhold  --target-arch <arch>        Haiku only: Specify the target architecture to
85483b28e4SIngo Weinhold                              build for. Must be one of the architectures of the
86483b28e4SIngo Weinhold                              host system. The installed build tools for that
87483b28e4SIngo Weinhold                              architecture will be used.
88483b28e4SIngo Weinhold                              This option can be specified multiple times. The
89483b28e4SIngo Weinhold                              first occurrence specifies the primary
90483b28e4SIngo Weinhold                              architecture of the Haiku to build, subsequent
91483b28e4SIngo Weinhold                              ones the secondary architectures.
92e70c4c64SPulkoMandy  --target-board <board>      ARM only: Specify the board to build for. Must be
93c0b833b1SAlexander von Gluck IV                              one of beagle,raspberry_pi,verdex.
947c4641d0SOliver Tappe  --update                    re-runs last configure invocation [must be given
957c4641d0SOliver Tappe                              as first option!]
96c2b76f7fSJonathan Schleifer  --use-clang                 Build with host Clang instead of GCC cross
97c2b76f7fSJonathan Schleifer                              compiler
98eccc7665SIngo Weinhold  --use-gcc-pipe              Build with GCC option -pipe. Speeds up the build
995a34a443SFrançois Revol                              process, but uses more memory.
100ed38d2efSJerome Duval  --use-gcc-graphite          Build with GCC Graphite engine for loop
101ed38d2efSJerome Duval                              optimizations. Only for gcc 4.
1020385b065SIngo Weinhold  --use-32bit                 Use -m32 flag on 64bit host gcc compiler.
103bc96e8f3SIngo Weinhold  --use-xattr                 Use Linux xattr respectively *BSD extattr support
104bc96e8f3SIngo Weinhold                              for BeOS attribute emulation. Warning: Make sure
105bc96e8f3SIngo Weinhold                              your file system supports sufficient attribute
106bc96e8f3SIngo Weinhold                              sizes (4 KB per file for all attributes won't
107bc96e8f3SIngo Weinhold                              suffice).
108bc96e8f3SIngo Weinhold  --use-xattr-ref             Use the generic BeOS attribute emulation, but use
109bc96e8f3SIngo Weinhold                              Linux xattr respectively *BSD extattr support to
110bc96e8f3SIngo Weinhold                              make it more robust (i.e. attribute mix-ups become
111bc96e8f3SIngo Weinhold                              less likely).
112338b8dc3SIngo Weinhold
113338b8dc3SIngo Weinholdenvironment variables:
114c0e8cc1aSIngo Weinhold  HAIKU_AR_x86_gcc2           The static library archiver for x86_gcc2.
115c0e8cc1aSIngo Weinhold                              Defaults to "ar".
116c0e8cc1aSIngo Weinhold  HAIKU_CC_x86_gcc2           The x86_gcc2 compiler. Defaults to "gcc".
117c0e8cc1aSIngo Weinhold  HAIKU_LD_x86_gcc2           The x86_gcc2 linker. Defaults to "ld".
118c0e8cc1aSIngo Weinhold  HAIKU_OBJCOPY_x86_gcc2      The x86_gcc2 objcopy to be used. Defaults to
119c0e8cc1aSIngo Weinhold                              "objcopy".
120c0e8cc1aSIngo Weinhold  HAIKU_RANLIB_x86_gcc2       The static library indexer for x86_gcc2. Defaults
121c0e8cc1aSIngo Weinhold                              to "ranlib".
122c0e8cc1aSIngo Weinhold  HAIKU_STRIP_x86_gcc2        The x86_gcc2 strip command. Defaults to "strip".
123a04a520bSJonathan Schleifer  HAIKU_NASM                  The nasm assembler (x86 and x86_64 only).
124c0e8cc1aSIngo Weinhold  HAIKU_CPPFLAGS_<arch>       The preprocessor flags for target architecture
125c0e8cc1aSIngo Weinhold                              <arch>. Defaults to "".
126c0e8cc1aSIngo Weinhold  HAIKU_CCFLAGS_<arch>        The C flags for target architecture <arch>.
127c0e8cc1aSIngo Weinhold                              Defaults to "".
128c0e8cc1aSIngo Weinhold  HAIKU_CXXFLAGS_<arch>       The C++ flags for target architecture <arch>.
129c0e8cc1aSIngo Weinhold                              Defaults to "".
130c0e8cc1aSIngo Weinhold  HAIKU_LDFLAGS_<arch>        The linker flags for target architecture <arch>.
131c0e8cc1aSIngo Weinhold                              Defaults to "".
132c0e8cc1aSIngo Weinhold  HAIKU_ARFLAGS_<arch>        The flags passed to HAIKU_AR for target
133c0e8cc1aSIngo Weinhold                              architecture <arch> for archiving. Defaults to
134c0e8cc1aSIngo Weinhold                              "cru".
135c0e8cc1aSIngo Weinhold  HAIKU_UNARFLAGS_<arch>      The flags passed to HAIKU_AR for target
136c0e8cc1aSIngo Weinhold                              architecture <arch> for unarchiving. Defaults to
137c0e8cc1aSIngo Weinhold                              "x".
13864f6da31SIngo Weinhold
139c0e8cc1aSIngo WeinholdNon-default output directories:
14064f6da31SIngo Weinhold  By default all objects, build configuration, and other related files are
14164f6da31SIngo Weinhold  stored in /path/to/haiku_source/generated.  To store objects in a non-default
14264f6da31SIngo Weinhold  location, run "../../relative/path/to/haiku_source/configure <options>" from
14364f6da31SIngo Weinhold  within your non-default location.  "jam [ options ] targets" can then be run
14464f6da31SIngo Weinhold  directly inside your non-default location.  Another option is to invoke "jam
14564f6da31SIngo Weinhold  [ options ] targets" from within haiku_source.  This can be accomplished by
14664f6da31SIngo Weinhold  either "export HAIKU_OUTPUT_DIR=your non-default location" before invoking
14764f6da31SIngo Weinhold  jam or by creating a symlink of haiku_source/generated pointing to your
14864f6da31SIngo Weinhold  non-default location and running jam.
14964f6da31SIngo Weinhold
15064f6da31SIngo Weinhold
151022fa244SIngo WeinholdEOF
152022fa244SIngo Weinhold}
153022fa244SIngo Weinhold
154022fa244SIngo Weinhold# assertparam
155022fa244SIngo Weinhold#
156022fa244SIngo Weinhold# Checks whether at least one parameter is left.
157022fa244SIngo Weinhold#
158022fa244SIngo Weinholdassertparam()
159022fa244SIngo Weinhold{
16020ab75e6SIngo Weinhold	if [ $2 -lt 2 ]; then
161022fa244SIngo Weinhold		echo $0: \`$1\': Parameter expected.
162022fa244SIngo Weinhold		exit 1
163022fa244SIngo Weinhold	fi
164022fa244SIngo Weinhold}
165022fa244SIngo Weinhold
16620ab75e6SIngo Weinhold# assertparams
16720ab75e6SIngo Weinhold#
16820ab75e6SIngo Weinhold# Checks whether at least a certain number of parameters is left.
16920ab75e6SIngo Weinhold#
17020ab75e6SIngo Weinholdassertparams()
17120ab75e6SIngo Weinhold{
17220ab75e6SIngo Weinhold	if [ $3 -le $2 ]; then
17320ab75e6SIngo Weinhold		echo $0: \`$1\': Not enough parameters.
17420ab75e6SIngo Weinhold		exit 1
17520ab75e6SIngo Weinhold	fi
17620ab75e6SIngo Weinhold}
17720ab75e6SIngo Weinhold
178e173a1ecSIngo Weinhold# absolute_path
179e173a1ecSIngo Weinhold#
180e173a1ecSIngo Weinhold# returns the absolute path of a given path.
181e173a1ecSIngo Weinhold#
182e173a1ecSIngo Weinholdabsolute_path()
183e173a1ecSIngo Weinhold{
1846a4f3954SFrançois Revol	if [ "x$1" != "x${1#/}" ]; then
185e173a1ecSIngo Weinhold		echo "$1"
186e173a1ecSIngo Weinhold	else
187e173a1ecSIngo Weinhold		echo "`pwd`/$1"
188e173a1ecSIngo Weinhold	fi
189e173a1ecSIngo Weinhold}
190e173a1ecSIngo Weinhold
19139d444a3SArvind S Raj# check_dir_exists
19239d444a3SArvind S Raj#
19339d444a3SArvind S Raj# check if a directory exists or not
19439d444a3SArvind S Raj#
19539d444a3SArvind S Rajcheck_dir_exists()
19639d444a3SArvind S Raj{
19739d444a3SArvind S Raj	if [ -d "$1" ]; then
19839d444a3SArvind S Raj		return 0
19939d444a3SArvind S Raj	else
20039d444a3SArvind S Raj		return 1
20139d444a3SArvind S Raj	fi
20239d444a3SArvind S Raj}
20339d444a3SArvind S Raj
204502882dbSJessica Hamilton# check_file_exists
205502882dbSJessica Hamilton#
206502882dbSJessica Hamilton# check if a file exists or not
207502882dbSJessica Hamilton#
208502882dbSJessica Hamiltoncheck_file_exists()
209502882dbSJessica Hamilton{
210502882dbSJessica Hamilton	if [ -f "$1" ]; then
211502882dbSJessica Hamilton		return 0
212502882dbSJessica Hamilton	else
213502882dbSJessica Hamilton		return 1
214502882dbSJessica Hamilton	fi
215502882dbSJessica Hamilton}
216502882dbSJessica Hamilton
2179a001156SOliver Tappe# real_path
2189a001156SOliver Tappe#
2199a001156SOliver Tappe# returns the realpath of a symbolic link.
2209a001156SOliver Tappe#
2219a001156SOliver Tappereal_path()
2229a001156SOliver Tappe{
2239a001156SOliver Tappe	perl -MCwd=realpath -e'print realpath($ARGV[0]), "\n"' "$1"
2249a001156SOliver Tappe}
2259a001156SOliver Tappe
22609c5682dSIngo Weinhold# standard_gcc_settings
22709c5682dSIngo Weinhold#
22809c5682dSIngo Weinhold# Sets the variables for a GCC platform.
22909c5682dSIngo Weinhold#
23009c5682dSIngo Weinholdstandard_gcc_settings()
23109c5682dSIngo Weinhold{
232c0e8cc1aSIngo Weinhold	local gcc=$1
233c0e8cc1aSIngo Weinhold
234138f5fb4SIngo Weinhold	if which greadlink > /dev/null 2>&1; then
235b29b48b1SMatt Madia		readlink="greadlink -e"
236138f5fb4SIngo Weinhold	elif which realpath > /dev/null 2>&1; then
237b29b48b1SMatt Madia		readlink=realpath
2389a001156SOliver Tappe	elif readlink -e / > /dev/null 2>&1; then
239b29b48b1SMatt Madia		readlink="readlink -e"
2409a001156SOliver Tappe	else
2419a001156SOliver Tappe		readlink=real_path
242b4b6d83cSMatt Madia	fi
243138f5fb4SIngo Weinhold
24409c5682dSIngo Weinhold	# PLATFORM_LINKLIBS
245c0e8cc1aSIngo Weinhold	local gcclib=`$gcc -print-libgcc-file-name`
246c0e8cc1aSIngo Weinhold	local gccdir=`dirname ${gcclib}`
2475b0f7b1bSOliver Tappe
248c0e8cc1aSIngo Weinhold	local gccRawVersion=`$gcc -dumpversion`
249c0e8cc1aSIngo Weinhold	local gccMachine=`$gcc -dumpmachine`
250338b8dc3SIngo Weinhold
251c0e8cc1aSIngo Weinhold	local libgcc=${gccdir}/libgcc.a
2528b5934c9SIngo Weinhold
253fc8967f1SIngo Weinhold	# determine architecture from machine triple
254c0e8cc1aSIngo Weinhold	case $gccMachine in
255c0e8cc1aSIngo Weinhold		arm-*)		targetCpu=arm;;
256c0e8cc1aSIngo Weinhold		i?86-*)		targetCpu=x86;;
257c0e8cc1aSIngo Weinhold		m68k-*)		targetCpu=m68k;;
258c0e8cc1aSIngo Weinhold		powerpc-*)	targetCpu=ppc;;
259c0e8cc1aSIngo Weinhold		x86_64-*)	targetCpu=x86_64;;
260fc8967f1SIngo Weinhold		*)
261c0e8cc1aSIngo Weinhold			echo "Unsupported gcc target machine: $gccMachine" >&2
262fc8967f1SIngo Weinhold			exit 1
263fc8967f1SIngo Weinhold			;;
264fc8967f1SIngo Weinhold	esac
265fc8967f1SIngo Weinhold
266c0e8cc1aSIngo Weinhold	local targetArch=$targetCpu
267c0e8cc1aSIngo Weinhold	local staticLibStdCxx
268c0e8cc1aSIngo Weinhold	local sharedLibStdCxx
269c0e8cc1aSIngo Weinhold	local staticLibSupCxx
270c0e8cc1aSIngo Weinhold	local sharedLibSupCxx
271c0e8cc1aSIngo Weinhold	local kernelLibgcc
272c0e8cc1aSIngo Weinhold	local cxxHeaders
273fc8967f1SIngo Weinhold
274c0e8cc1aSIngo Weinhold	case $gccRawVersion in
2758b5934c9SIngo Weinhold		4.*)
2765b0f7b1bSOliver Tappe			# for gcc 4 we use the libstdc++ and libsupc++ that come with the
2775b0f7b1bSOliver Tappe			# compiler
278c0e8cc1aSIngo Weinhold			staticLibStdCxx=`$gcc -print-file-name=libstdc++.a`
279c0e8cc1aSIngo Weinhold			sharedLibStdCxx=`$gcc -print-file-name=libstdc++.so`
280c0e8cc1aSIngo Weinhold			staticLibSupCxx=`$gcc -print-file-name=libsupc++.a`
281c0e8cc1aSIngo Weinhold			sharedLibSupCxx=`$gcc -print-file-name=libsupc++.so`
28214210488SMichael Lotz
283aaeadfcbSAlex Smith			# If the architecture has separate runtime libraries for the
284aaeadfcbSAlex Smith			# kernel, use them.
285c0e8cc1aSIngo Weinhold			kernelLibgcc=`$gcc -print-file-name=libgcc-kernel.a`
286c0e8cc1aSIngo Weinhold			if [ $kernelLibgcc = libgcc-kernel.a ]; then
287c0e8cc1aSIngo Weinhold				kernelLibgcc=$libgcc
288aaeadfcbSAlex Smith			fi
289c0e8cc1aSIngo Weinhold			kernelLibSupCxx=`$gcc -print-file-name=libsupc++-kernel.a`
290c0e8cc1aSIngo Weinhold			if [ $kernelLibSupCxx = libsupc++-kernel.a ]; then
291c0e8cc1aSIngo Weinhold				kernelLibSupCxx=$staticLibSupCxx
292aaeadfcbSAlex Smith			fi
293aaeadfcbSAlex Smith
294c0e8cc1aSIngo Weinhold			local headersBase=$gccdir/../../../..
295c0e8cc1aSIngo Weinhold			local headers=$headersBase/$gccMachine/include/c++/$gccRawVersion
296c0e8cc1aSIngo Weinhold			if [ ! -d $headers ]; then
297c0e8cc1aSIngo Weinhold				headers=$headersBase/include/c++/$gccRawVersion
29814210488SMichael Lotz			fi
29914210488SMichael Lotz
300c0e8cc1aSIngo Weinhold			cxxHeaders=$headers
301c0e8cc1aSIngo Weinhold			for d in $gccMachine backward ext; do
30229ef597dSIngo Weinhold				# Note: We need the line break, otherwise the line might become
30329ef597dSIngo Weinhold				# too long for jam (512 bytes max).
304c0e8cc1aSIngo Weinhold				cxxHeaders="$cxxHeaders $headers/$d"
3058b5934c9SIngo Weinhold			done
306274b450aSMarcus Overhagen
3073f9f9f9aSIngo Weinhold			# Unset the HAIKU_{SHARED,STATIC}_LIB{STD,SUP}CXX variables, if the
3083f9f9f9aSIngo Weinhold			# compiler didn't give us actual file names. Otherwise resolve
3093f9f9f9aSIngo Weinhold			# symlinks to avoid problems when copying the libraries to the
3103f9f9f9aSIngo Weinhold			# image.
3118b5934c9SIngo Weinhold
312c0e8cc1aSIngo Weinhold			if [ $staticLibStdCxx = libstdc++.a ]; then
313c0e8cc1aSIngo Weinhold				staticLibStdCxx=
3143f9f9f9aSIngo Weinhold			else
315c0e8cc1aSIngo Weinhold				staticLibStdCxx=`$readlink $staticLibStdCxx`
3168b5934c9SIngo Weinhold			fi
3173f9f9f9aSIngo Weinhold
318c0e8cc1aSIngo Weinhold			if [ $sharedLibStdCxx = libstdc++.so ]; then
319c0e8cc1aSIngo Weinhold				sharedLibStdCxx=
3203f9f9f9aSIngo Weinhold			else
321c0e8cc1aSIngo Weinhold				sharedLibStdCxx=`$readlink $sharedLibStdCxx`
322ffe8b20cSIngo Weinhold			fi
3233f9f9f9aSIngo Weinhold
324c0e8cc1aSIngo Weinhold			if [ $staticLibSupCxx = libsupc++.a ]; then
325c0e8cc1aSIngo Weinhold				staticLibSupCxx=
3263f9f9f9aSIngo Weinhold			else
327c0e8cc1aSIngo Weinhold				staticLibSupCxx=`$readlink $staticLibSupCxx`
328c89fc875SIngo Weinhold			fi
3293f9f9f9aSIngo Weinhold
330c0e8cc1aSIngo Weinhold			if [ $sharedLibSupCxx = libsupc++.so ]; then
331c0e8cc1aSIngo Weinhold				sharedLibSupCxx=
3323f9f9f9aSIngo Weinhold			else
333c0e8cc1aSIngo Weinhold				sharedLibSupCxx=`$readlink $sharedLibSupCxx`
334ffe8b20cSIngo Weinhold			fi
3358b5934c9SIngo Weinhold			;;
3366cc8eecfSOliver Tappe		2.9*)
3375b0f7b1bSOliver Tappe			# check for correct (most up-to-date) legacy compiler and complain
3385b0f7b1bSOliver Tappe			# if an older one is installed
339c0e8cc1aSIngo Weinhold			if [ $gccRawVersion != $haikuRequiredLegacyGCCVersion ]; then
3405b0f7b1bSOliver Tappe				echo "GCC version $haikuRequiredLegacyGCCVersion is required!";
3415b0f7b1bSOliver Tappe				echo "Please download it from www.haiku-os.org...";
3425b0f7b1bSOliver Tappe				exit 1;
3435b0f7b1bSOliver Tappe			fi
344aaeadfcbSAlex Smith
345c0e8cc1aSIngo Weinhold			kernelLibgcc=$libgcc
346c0e8cc1aSIngo Weinhold			kernelLibSupCxx=
347c0e8cc1aSIngo Weinhold			targetArch=x86_gcc2
3485b0f7b1bSOliver Tappe			;;
3498b5934c9SIngo Weinhold	esac
35065ad1ba3SAlex Smith
351c0e8cc1aSIngo Weinhold	local bootLibgcc
352c0e8cc1aSIngo Weinhold	local bootLibSupCxx
35366a7f29fSJérôme Duval	local bootCxxHeaders
354c0e8cc1aSIngo Weinhold	case $gccMachine in
3554591ebc9SAlex Smith		x86_64-*)
35666a7f29fSJérôme Duval			# Boot loader is 32-bit, need the 32-bit libs and c++ config
357c0e8cc1aSIngo Weinhold			bootLibgcc=`$gcc -m32 -print-libgcc-file-name`
358c0e8cc1aSIngo Weinhold			bootLibSupCxx=`$gcc -m32 -print-file-name=libsupc++.a`
35966a7f29fSJérôme Duval
36066a7f29fSJérôme Duval			local headersBase=$gccdir/../../../..
36166a7f29fSJérôme Duval			local headers=$headersBase/$gccMachine/include/c++/$gccRawVersion
36266a7f29fSJérôme Duval			if [ ! -d $headers ]; then
36366a7f29fSJérôme Duval				headers=$headersBase/include/c++/$gccRawVersion
36466a7f29fSJérôme Duval			fi
36566a7f29fSJérôme Duval			bootCxxHeaders="$headers/$gccMachine/32"
3664591ebc9SAlex Smith			;;
3674591ebc9SAlex Smith		*)
368c0e8cc1aSIngo Weinhold			bootLibgcc=$libgcc
369c0e8cc1aSIngo Weinhold			bootLibSupCxx=$staticLibSupCxx
370338b8dc3SIngo Weinhold			;;
371338b8dc3SIngo Weinhold	esac
372c0e8cc1aSIngo Weinhold
373c0e8cc1aSIngo Weinhold	# determine whether graphite loop optimization should/can be used
374c0e8cc1aSIngo Weinhold	local useGraphite=`get_variable HAIKU_USE_GCC_GRAPHITE_$targetCpu`
375c0e8cc1aSIngo Weinhold	if [ -z "$useGraphite" ]; then
376c0e8cc1aSIngo Weinhold		useGraphite=$useGccGraphiteDefault
377c0e8cc1aSIngo Weinhold	fi
378c0e8cc1aSIngo Weinhold
379c0e8cc1aSIngo Weinhold	if [ "$useGraphite" != 0 ]; then
380c0e8cc1aSIngo Weinhold		UNUSED=`echo "int main() {}" | $gcc -xc -c -floop-block - 2>&1`
381c0e8cc1aSIngo Weinhold		if [ $? != 0 ]; then
382c0e8cc1aSIngo Weinhold			echo "GCC Graphite loop optimizations cannot be used on $targetArch"
383c0e8cc1aSIngo Weinhold			useGraphite=0
384c0e8cc1aSIngo Weinhold		fi
385c0e8cc1aSIngo Weinhold	fi
386c0e8cc1aSIngo Weinhold
387c0e8cc1aSIngo Weinhold	set_variable HAIKU_CPU_$targetArch $targetCpu
388c0e8cc1aSIngo Weinhold
389c0e8cc1aSIngo Weinhold	get_build_tool_path CC_$targetArch "$gcc"
390c2b76f7fSJonathan Schleifer	if [ $useClang = 1 ]; then
391c2b76f7fSJonathan Schleifer		# The get_build_tool_path above is needed to get the path to the rest
392c2b76f7fSJonathan Schleifer		# of the build tools
393c2b76f7fSJonathan Schleifer		local path=`dirname $(get_variable HAIKU_CC_$targetArch)`
394c2b76f7fSJonathan Schleifer		set_variable HAIKU_CC_$targetArch \
395c2b76f7fSJonathan Schleifer			"PATH=\\\"$path:\\\$PATH\\\" clang -target $gccMachine"
396c2b76f7fSJonathan Schleifer		set_variable HAIKU_CC_IS_CLANG_$targetArch 1
397c2b76f7fSJonathan Schleifer	else
398c2b76f7fSJonathan Schleifer		set_variable HAIKU_CC_IS_CLANG_$targetArch 0
399c2b76f7fSJonathan Schleifer	fi
400c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_RAW_VERSION_$targetArch $gccRawVersion
401c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_MACHINE_$targetArch $gccMachine
402c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_LIB_DIR_$targetArch $gccdir
403c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_LIBGCC_$targetArch $libgcc
404c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_GLUE_CODE_$targetArch "crtbegin.o crtend.o"
405c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_HEADERS_DIR_$targetArch \
406c0e8cc1aSIngo Weinhold		"${gccdir}/include ${gccdir}/include-fixed"
407c0e8cc1aSIngo Weinhold	set_variable HAIKU_STATIC_LIBSTDCXX_$targetArch "$staticLibStdCxx"
408c0e8cc1aSIngo Weinhold	set_variable HAIKU_SHARED_LIBSTDCXX_$targetArch "$sharedLibStdCxx"
409c0e8cc1aSIngo Weinhold	set_variable HAIKU_STATIC_LIBSUPCXX_$targetArch "$staticLibSupCxx"
410c0e8cc1aSIngo Weinhold	set_variable HAIKU_SHARED_LIBSUPCXX_$targetArch "$sharedLibSupCxx"
411c0e8cc1aSIngo Weinhold	set_variable HAIKU_KERNEL_LIBSUPCXX_$targetArch "$kernelLibSupCxx"
412c0e8cc1aSIngo Weinhold	set_variable HAIKU_BOOT_LIBSUPCXX_$targetArch "$bootLibSupCxx"
413c0e8cc1aSIngo Weinhold	set_variable HAIKU_KERNEL_LIBGCC_$targetArch $kernelLibgcc
414c0e8cc1aSIngo Weinhold	set_variable HAIKU_CXX_HEADERS_DIR_$targetArch "$cxxHeaders"
415c0e8cc1aSIngo Weinhold	set_variable HAIKU_BOOT_LIBGCC_$targetArch $bootLibgcc
41666a7f29fSJérôme Duval	set_variable HAIKU_BOOT_CXX_HEADERS_DIR_$targetArch "$bootCxxHeaders"
417c0e8cc1aSIngo Weinhold	set_variable HAIKU_USE_GCC_GRAPHITE_$targetArch $useGraphite
418c0e8cc1aSIngo Weinhold
419c0e8cc1aSIngo Weinhold	standard_gcc_settings_targetArch=$targetArch
420c0e8cc1aSIngo Weinhold}
421c0e8cc1aSIngo Weinhold
422c0e8cc1aSIngo Weinhold# set_variable
423c0e8cc1aSIngo Weinhold#
424c0e8cc1aSIngo Weinhold# Set the value of a variable.
425c0e8cc1aSIngo Weinhold#
426c0e8cc1aSIngo Weinholdset_variable()
427c0e8cc1aSIngo Weinhold{
428c0e8cc1aSIngo Weinhold	eval "$1=\"$2\""
429c0e8cc1aSIngo Weinhold}
430c0e8cc1aSIngo Weinhold
431c0e8cc1aSIngo Weinhold# get_variable
432c0e8cc1aSIngo Weinhold#
433c0e8cc1aSIngo Weinhold# Echo the value of a variable.
434c0e8cc1aSIngo Weinhold#
435c0e8cc1aSIngo Weinholdget_variable()
436c0e8cc1aSIngo Weinhold{
437c0e8cc1aSIngo Weinhold	eval "echo \${$1}"
43809c5682dSIngo Weinhold}
43909c5682dSIngo Weinhold
440338b8dc3SIngo Weinhold# set_default_value
441338b8dc3SIngo Weinhold#
442338b8dc3SIngo Weinhold# Set the value for a variable, if no value is set yet.
443338b8dc3SIngo Weinhold#
444338b8dc3SIngo Weinholdset_default_value()
445338b8dc3SIngo Weinhold{
446338b8dc3SIngo Weinhold	eval "$1=\${$1-$2}"
447338b8dc3SIngo Weinhold}
448338b8dc3SIngo Weinhold
449338b8dc3SIngo Weinhold# get_build_tool_path
450338b8dc3SIngo Weinhold#
451338b8dc3SIngo Weinhold# Gets a usable absolute path of a build tool.
452338b8dc3SIngo Weinhold#
453338b8dc3SIngo Weinholdget_build_tool_path()
454338b8dc3SIngo Weinhold{
455338b8dc3SIngo Weinhold	local var="HAIKU_$1"
456c0e8cc1aSIngo Weinhold	local path=$2
457338b8dc3SIngo Weinhold
458338b8dc3SIngo Weinhold	if [ -f "$path" ]; then
459338b8dc3SIngo Weinhold		# get absolute path
460a559f87aSFrançois Revol		local oldPwd="`pwd`"
461a559f87aSFrançois Revol		cd "`dirname "$path"`"
462a559f87aSFrançois Revol		path="`pwd`/`basename "$path"`"
463338b8dc3SIngo Weinhold		cd $oldPwd
464338b8dc3SIngo Weinhold	else
4657fe2e06cSMatt Madia		which "$path" > /dev/null 2>&1 || {
466338b8dc3SIngo Weinhold			echo "Build tool \"$path\" not found." >&2
467338b8dc3SIngo Weinhold			exit 1
468338b8dc3SIngo Weinhold		}
469338b8dc3SIngo Weinhold	fi
470338b8dc3SIngo Weinhold
471338b8dc3SIngo Weinhold	eval "$var=$path"
472338b8dc3SIngo Weinhold}
473338b8dc3SIngo Weinhold
474483b28e4SIngo Weinholdis_in_list()
475483b28e4SIngo Weinhold{
476483b28e4SIngo Weinhold	local element
477483b28e4SIngo Weinhold	for element in $2; do
478483b28e4SIngo Weinhold		if [ "$1" = "$element" ]; then
479483b28e4SIngo Weinhold			return 0
480483b28e4SIngo Weinhold		fi
481483b28e4SIngo Weinhold	done
482483b28e4SIngo Weinhold	return 1
483483b28e4SIngo Weinhold}
484483b28e4SIngo Weinhold
485338b8dc3SIngo Weinhold# get cwd and the source directory
486338b8dc3SIngo WeinholdcurrentDir=`pwd`
4876e7c6fe5SIngo Weinholdcd `dirname "$0"`
488338b8dc3SIngo WeinholdsourceDir=`pwd`
4896e7c6fe5SIngo Weinholdcd "$currentDir"
490338b8dc3SIngo Weinhold
49155d267a4SFrançois Revol# backup the passed arguments
49255d267a4SFrançois RevolconfigureArgs="$@"
49355d267a4SFrançois Revol
4947c4641d0SOliver Tappe# internal default parameter values
495022fa244SIngo Weinhold#
49652a38012Sejakowatzplatform=`uname`
4975abd9a46SIngo WeinholdplatformMachine=`uname  -m`
498c0e8cc1aSIngo WeinholdtargetArchs=
499338b8dc3SIngo WeinholdbuildCrossTools=
50029ef597dSIngo WeinholdbuildCrossToolsScript="$sourceDir/build/scripts/build_cross_tools"
50160d8d8fcSIngo WeinholdbuildCrossToolsJobs=
502c2b76f7fSJonathan SchleiferuseClang=0
503c0e8cc1aSIngo WeinholduseGccGraphiteDefault=0
504c0e8cc1aSIngo WeinholdunknownArchIndex=1
505483b28e4SIngo WeinholdhaikuTargetArchs=
5067c4641d0SOliver Tappe
5077c4641d0SOliver Tappe# exported (BuildSetup) default parameter values
5087c4641d0SOliver Tappe#
5097c4641d0SOliver TappeHOST_GCC_RAW_VERSION=`gcc -dumpversion`
5107c4641d0SOliver TappeHOST_GCC_MACHINE=`gcc -dumpmachine`
5117c4641d0SOliver TappeHAIKU_INCLUDE_GPL_ADDONS=0
5127c4641d0SOliver TappeHAIKU_INCLUDE_PATENTED_CODE=0
51376fa0be3SIngo WeinholdHAIKU_INCLUDE_SOURCES=0
5147c4641d0SOliver TappeHAIKU_INCLUDE_3RDPARTY=0
5157c4641d0SOliver TappeHAIKU_ENABLE_MULTIUSER=0
5167c4641d0SOliver TappeHAIKU_DISTRO_COMPATIBILITY=default
5177c4641d0SOliver TappeTARGET_PLATFORM=haiku
5187c4641d0SOliver TappeHAIKU_USE_GCC_PIPE=0
5197986925fSIngo WeinholdHAIKU_HOST_USE_32BIT=0
5207986925fSIngo WeinholdHAIKU_HOST_USE_XATTR=0
521bc96e8f3SIngo WeinholdHAIKU_HOST_USE_XATTR_REF=0
5222ebcd86dSIngo WeinholdHAIKU_HOST_BUILD_ONLY=0
523f04f7042SNiels Sascha ReedijkHOST_EXTENDED_REGEX_SED="sed -r"
5247c4641d0SOliver TappeHOST_GCC_LD=`gcc -print-prog-name=ld`
5257c4641d0SOliver TappeHOST_GCC_OBJCOPY=`gcc -print-prog-name=objcopy`
526c505b276SFrançois RevolSFDISK_BINARY=sfdisk
527c505b276SFrançois RevolHOST_SFDISK=$SFDISK_BINARY
5282a5d0aafSIngo WeinholdHOST_SHA256=
529e173a1ecSIngo WeinholdHOST_HAIKU_PORTER=
530e173a1ecSIngo WeinholdHAIKU_PORTS=
531e173a1ecSIngo WeinholdHAIKU_PORTS_CROSS=
532e70c4c64SPulkoMandyHAIKU_BOOT_BOARD=
533*aa2e5ecaSOliver TappeHAIKU_NO_DOWNLOADS=0
5342a5d0aafSIngo Weinhold
535c0e8cc1aSIngo WeinholdHAIKU_PACKAGING_ARCHS=
536c0e8cc1aSIngo Weinhold
537a04a520bSJonathan Schleiferset_default_value HAIKU_NASM		nasm
538c0e8cc1aSIngo Weinhold
5393942ca0dSIngo Weinholdif sha256sum < /dev/null > /dev/null 2>&1; then
5402a5d0aafSIngo Weinhold	HOST_SHA256=sha256sum
5413942ca0dSIngo Weinholdelif sha256 < /dev/null > /dev/null 2>&1; then
5422a5d0aafSIngo Weinhold	HOST_SHA256="sha256 -q"
543b5a871b1SNiels Sascha Reedijkelif shasum < /dev/null > /dev/null 2>&1; then
544b5a871b1SNiels Sascha Reedijk	HOST_SHA256="shasum -a 256"
5452a5d0aafSIngo Weinholdelse
5462a5d0aafSIngo Weinhold	echo "Error: Neither sha256sum nor sha256 seem to be available!" >&2
5472a5d0aafSIngo Weinhold	exit 1
5482a5d0aafSIngo Weinholdfi
549338b8dc3SIngo Weinhold
550cc91b333SIngo WeinholdhaikuRequiredLegacyGCCVersion="2.95.3-haiku-2013_08_15"
551a559f87aSFrançois Revolexport haikuRequiredLegacyGCCVersion
552af4bf973SOliver Tappe	# version of legacy gcc required to build haiku
553483b28e4SIngo WeinholdsupportedTargetArchs="
554483b28e4SIngo Weinhold	arm
555483b28e4SIngo Weinhold	m68k
556483b28e4SIngo Weinhold	ppc
557483b28e4SIngo Weinhold	x86
558483b28e4SIngo Weinhold	x86_64
559483b28e4SIngo Weinhold	x86_gcc2
560483b28e4SIngo Weinhold	"
561e70c4c64SPulkoMandysupportedTargetBoards="
562e70c4c64SPulkoMandy	beagle
563c0b833b1SAlexander von Gluck IV	raspberry_pi
564e70c4c64SPulkoMandy	verdex
565e70c4c64SPulkoMandy	"
566af4bf973SOliver Tappe
5677c4641d0SOliver Tappe# determine output directory
5687c4641d0SOliver Tappeif [ "$currentDir" = "$sourceDir" ]; then
5697c4641d0SOliver Tappe	outputDir=$currentDir/generated
5707c4641d0SOliver Tappeelse
5717c4641d0SOliver Tappe	outputDir=$currentDir
5727c4641d0SOliver Tappefi
5737c4641d0SOliver TappebuildOutputDir="$outputDir/build"
5747c4641d0SOliver TappeHAIKU_BUILD_ATTRIBUTES_DIR="$outputDir/attributes"
5757c4641d0SOliver TappebuildConfigFile="$buildOutputDir/BuildConfig"
5767c4641d0SOliver Tappe
5777c4641d0SOliver Tappe# check for update request
5787c4641d0SOliver Tappeif [ "$1" = "--update" ]; then
5797c4641d0SOliver Tappe	if ! [ -e "$buildConfigFile" ]; then
5807c4641d0SOliver Tappe		echo $0 --update: \'$buildConfigFile\' not found - updating not possible.
5817c4641d0SOliver Tappe		exit 1
5827c4641d0SOliver Tappe	fi
5837c4641d0SOliver Tappe	if ! type perl >/dev/null 2>&1; then
5847c4641d0SOliver Tappe		echo $0 --update: \'perl\' not found - updating not possible.
5857c4641d0SOliver Tappe		exit 1
5867c4641d0SOliver Tappe	fi
5877c4641d0SOliver Tappe	# convert BuildConfig from jam format to shell format and evaluate it
5887c4641d0SOliver Tappe	shellConfigFile="${buildConfigFile}.shell"
5897c4641d0SOliver Tappe	perl "$sourceDir/build/scripts/convert_build_config_to_shell_format.pl" \
5907c4641d0SOliver Tappe		<"$buildConfigFile" >"$shellConfigFile"
5917c4641d0SOliver Tappe	. "$shellConfigFile"
5927c4641d0SOliver Tappe	rm "$shellConfigFile"
5937c4641d0SOliver Tappe	shift
5947c4641d0SOliver Tappefi
5957c4641d0SOliver Tappe
596022fa244SIngo Weinhold# parse parameters
597022fa244SIngo Weinhold#
59820ab75e6SIngo Weinholdwhile [ $# -gt 0 ] ; do
599022fa244SIngo Weinhold	case "$1" in
600e173a1ecSIngo Weinhold		--bootstrap)
601e173a1ecSIngo Weinhold			assertparams "$1" 3 $#
602e173a1ecSIngo Weinhold			HOST_HAIKU_PORTER="`absolute_path $2`"
603e173a1ecSIngo Weinhold			HAIKU_PORTS_CROSS="`absolute_path $3`"
604e173a1ecSIngo Weinhold			HAIKU_PORTS="`absolute_path $4`"
605502882dbSJessica Hamilton			check_file_exists "$HOST_HAIKU_PORTER" || (
606502882dbSJessica Hamilton				echo "Invalid path to haikuporter: $HOST_HAIKU_PORTER" >&2
60739d444a3SArvind S Raj				exit 1
60839d444a3SArvind S Raj			)
60939d444a3SArvind S Raj			check_dir_exists "$HAIKU_PORTS" || (
61039d444a3SArvind S Raj				echo "Non-existent directory $HAIKU_PORTS" >&2
61139d444a3SArvind S Raj				exit 1
61239d444a3SArvind S Raj			)
61339d444a3SArvind S Raj			check_dir_exists "$HAIKU_PORTS_CROSS" || (
61439d444a3SArvind S Raj				echo "Non-existent directory $HAIKU_PORTS_CROSS" >&2
61539d444a3SArvind S Raj				exit 1
61639d444a3SArvind S Raj			)
617e173a1ecSIngo Weinhold			shift 4
618e173a1ecSIngo Weinhold			;;
619c0e8cc1aSIngo Weinhold		--build-cross-tools)
620c0e8cc1aSIngo Weinhold			if [ -z "$buildCrossTools" ]; then
6219b0dd528SIngo Weinhold				assertparams "$1" 2 $#
622c0e8cc1aSIngo Weinhold				targetArch=$2
6239b0dd528SIngo Weinhold				buildCrossTools=$3
6249b0dd528SIngo Weinhold				shift 3
625c0e8cc1aSIngo Weinhold			else
626c0e8cc1aSIngo Weinhold				assertparam "$1" $#
627c0e8cc1aSIngo Weinhold				targetArch=$2
628c0e8cc1aSIngo Weinhold				shift 2
629c0e8cc1aSIngo Weinhold			fi
630c0e8cc1aSIngo Weinhold			case "$targetArch" in
631c0e8cc1aSIngo Weinhold				x86_gcc2)	targetMachine=i586-pc-haiku;;
632c0e8cc1aSIngo Weinhold				x86)		targetMachine=i586-pc-haiku;;
633c0e8cc1aSIngo Weinhold				x86_64)		targetMachine=x86_64-unknown-haiku;;
634c0e8cc1aSIngo Weinhold				ppc)		targetMachine=powerpc-apple-haiku;;
635c0e8cc1aSIngo Weinhold				m68k)		targetMachine=m68k-unknown-haiku;;
636c0e8cc1aSIngo Weinhold				arm)		targetMachine=arm-unknown-haiku;;
637c0e8cc1aSIngo Weinhold				*)
638c0e8cc1aSIngo Weinhold					echo "Unsupported target architecture: $2" >&2
639c0e8cc1aSIngo Weinhold					exit 1
640c0e8cc1aSIngo Weinhold					;;
641c0e8cc1aSIngo Weinhold			esac
642c0e8cc1aSIngo Weinhold			set_variable buildCrossToolsMachine_$targetArch $targetMachine
643c0e8cc1aSIngo Weinhold			targetArchs="$targetArchs $targetArch"
644c0e8cc1aSIngo Weinhold			HAIKU_PACKAGING_ARCHS=
6459b0dd528SIngo Weinhold			;;
6469b0dd528SIngo Weinhold		--cross-tools-prefix)
6479b0dd528SIngo Weinhold			assertparam "$1" $#
648c0e8cc1aSIngo Weinhold			targetArch=unknown${unknownArchIndex}
649c0e8cc1aSIngo Weinhold			set_variable crossToolsPrefix_$targetArch "$2"
650c0e8cc1aSIngo Weinhold			targetArchs="$targetArchs $targetArch"
651c0e8cc1aSIngo Weinhold			HAIKU_PACKAGING_ARCHS=
652d68208faSMatt Madia			unknownArchIndex=$(($unknownArchIndex + 1))
6539b0dd528SIngo Weinhold			shift 2
6549b0dd528SIngo Weinhold			;;
655a66c32ddSIngo Weinhold		--distro-compatibility)
6569b0dd528SIngo Weinhold			assertparam "$1" $#
6577c4641d0SOliver Tappe			HAIKU_DISTRO_COMPATIBILITY=$2
6587c4641d0SOliver Tappe			case "$HAIKU_DISTRO_COMPATIBILITY" in
659a66c32ddSIngo Weinhold				official)	;;
660a66c32ddSIngo Weinhold				compatible)	;;
661a66c32ddSIngo Weinhold				default)	;;
662a66c32ddSIngo Weinhold				*)			echo "Invalid distro compatibility" \
6637c4641d0SOliver Tappe								"level: $HAIKU_DISTRO_COMPATIBILITY"
664a66c32ddSIngo Weinhold							exit 1;;
665a66c32ddSIngo Weinhold			esac
6669b0dd528SIngo Weinhold			shift 2
6679b0dd528SIngo Weinhold			;;
6687c4641d0SOliver Tappe		--enable-multiuser)	HAIKU_ENABLE_MULTIUSER=1; shift 1;;
66960d8d8fcSIngo Weinhold		--help | -h)	usage; exit 0;;
6702ebcd86dSIngo Weinhold		--host-only)	HAIKU_HOST_BUILD_ONLY=1; shift 1;;
6717c4641d0SOliver Tappe		--include-gpl-addons)	HAIKU_INCLUDE_GPL_ADDONS=1; shift 1;;
6727c4641d0SOliver Tappe		--include-patented-code)	HAIKU_INCLUDE_PATENTED_CODE=1; shift 1;;
67376fa0be3SIngo Weinhold		--include-sources)	HAIKU_INCLUDE_SOURCES=1; shift 1;;
6747c4641d0SOliver Tappe		--include-3rdparty)	HAIKU_INCLUDE_3RDPARTY=1; shift 1;;
67560d8d8fcSIngo Weinhold        -j*)				buildCrossToolsJobs="$1"; shift 1;;
676*aa2e5ecaSOliver Tappe		--no-downloads)	HAIKU_NO_DOWNLOADS=1; shift 1;;
6777c4641d0SOliver Tappe		--target=*)     TARGET_PLATFORM=`echo $1 | cut -d'=' -f2-`; shift 1;;
678483b28e4SIngo Weinhold		--target-arch)
679483b28e4SIngo Weinhold			assertparam "$1" $#
680483b28e4SIngo Weinhold			targetArch=$2
681483b28e4SIngo Weinhold			shift 2
682483b28e4SIngo Weinhold			if [ ! "$platform" = Haiku ]; then
683483b28e4SIngo Weinhold				echo "--target-arch can only be specified on Haiku." >&2
684483b28e4SIngo Weinhold				exit 1
685483b28e4SIngo Weinhold			fi
686483b28e4SIngo Weinhold			is_in_list "$targetArch" "$supportedTargetArchs" || (
687483b28e4SIngo Weinhold				echo "Unsupported target architecture: \"$targetArch\"" >&2
688483b28e4SIngo Weinhold				exit 1
689483b28e4SIngo Weinhold			)
690483b28e4SIngo Weinhold			haikuTargetArchs="$haikuTargetArchs $targetArch"
691483b28e4SIngo Weinhold			;;
692e70c4c64SPulkoMandy		--target-board)
693e70c4c64SPulkoMandy			assertparam "$1" $#
694e70c4c64SPulkoMandy			HAIKU_BOOT_BOARD=$2
695e70c4c64SPulkoMandy			is_in_list "$HAIKU_BOOT_BOARD" "$supportedTargetBoards" || (
696e70c4c64SPulkoMandy				echo "Unsupported target board: \"$HAIKU_BOOT_BOARD\"" >&2
697e70c4c64SPulkoMandy				exit 1
698e70c4c64SPulkoMandy			)
699e70c4c64SPulkoMandy			shift 2
700e70c4c64SPulkoMandy			;;
701c2b76f7fSJonathan Schleifer		--use-clang) useClang=1; shift 1;;
7027c4641d0SOliver Tappe		--use-gcc-pipe)	HAIKU_USE_GCC_PIPE=1; shift 1;;
703c0e8cc1aSIngo Weinhold		--use-gcc-graphite)	useGccGraphiteDefault=1; shift 1;;
7047986925fSIngo Weinhold		--use-32bit)	HAIKU_HOST_USE_32BIT=1; shift 1;;
7057986925fSIngo Weinhold		--use-xattr)	HAIKU_HOST_USE_XATTR=1; shift 1;;
706bc96e8f3SIngo Weinhold		--use-xattr-ref)	HAIKU_HOST_USE_XATTR_REF=1; shift 1;;
707022fa244SIngo Weinhold		*)				echo Invalid argument: \`$1\'; exit 1;;
708022fa244SIngo Weinhold	esac
709022fa244SIngo Weinholddone
710022fa244SIngo Weinhold
7110df3cc9cSIngo Weinhold# detect the build platform
712338b8dc3SIngo Weinholdcase "${platform}" in
7137c4641d0SOliver Tappe	Darwin)	HOST_PLATFORM=darwin ;;
7147c4641d0SOliver Tappe	FreeBSD)	HOST_PLATFORM=freebsd
715c505b276SFrançois Revol				SFDISK_BINARY=sfdisk-linux
7167986925fSIngo Weinhold				if [ "$HAIKU_HOST_USE_32BIT" = 1 ] ; then
7175abd9a46SIngo Weinhold					echo Unsupported platform: FreeBSD ${platformMachine}
718308c212cSIngo Weinhold					exit 1
719308c212cSIngo Weinhold				fi	;;
7207c4641d0SOliver Tappe	Haiku)	HOST_PLATFORM=haiku_host ;;
7217c4641d0SOliver Tappe	Linux)	HOST_PLATFORM=linux ;;
7227c4641d0SOliver Tappe	OpenBSD) HOST_PLATFORM=openbsd ;;
7237c4641d0SOliver Tappe	SunOS)	HOST_PLATFORM=sunos ;;
7247c4641d0SOliver Tappe	CYGWIN_NT-*) HOST_PLATFORM=cygwin ;;
725338b8dc3SIngo Weinhold	*)		echo Unsupported platform: ${platform}
7264cbe4925SAxel Dörfler			exit 1 ;;
7274cbe4925SAxel Dörfleresac
72852a38012Sejakowatz
729c505b276SFrançois Revol# check common locations for sfdisk
730c505b276SFrançois Revolfor sfdiskDir in /sbin /usr/sbin /usr/local/sbin ; do
731c505b276SFrançois Revol	if [ -e ${sfdiskDir}/${SFDISK_BINARY} ]; then
732c505b276SFrançois Revol		HOST_SFDISK=${sfdiskDir}/${SFDISK_BINARY}
733c505b276SFrançois Revol	fi
734c505b276SFrançois Revoldone
735c505b276SFrançois Revol
7360962132cSAlex Smith# check for case-sensitive filesystem
7370962132cSAlex Smithmkdir haikuCaseTest 2>/dev/null
7380962132cSAlex Smithmkdir haikucasetest 2>/dev/null
7390962132cSAlex SmithcaseInsensitive=$?
74097f5a0bdSAlex Smithrmdir haikuCaseTest haikucasetest 2>/dev/null
7410962132cSAlex Smithif [ $caseInsensitive != 0 ]; then
7423ecc5287SMichael Lotz	echo "You need a case-sensitive file-system to build Haiku."
7430962132cSAlex Smith	if [ $HOST_PLATFORM = "darwin" ]; then
7440962132cSAlex Smith		echo "You can create a case-sensitive disk image using Disk Utility and use"
7450962132cSAlex Smith		echo "it to store the Haiku sources on."
7463ecc5287SMichael Lotz	fi
7470962132cSAlex Smith	exit 1
7483ecc5287SMichael Lotzfi
7493ecc5287SMichael Lotz
750f04f7042SNiels Sascha Reedijk# determine how to invoke sed with extended regexp support for non-GNU sed
751f04f7042SNiels Sascha Reedijkif [ $HOST_PLATFORM = "darwin" ]; then
752f04f7042SNiels Sascha Reedijk	HOST_EXTENDED_REGEX_SED="sed -E"
753f04f7042SNiels Sascha Reedijkfi
754f04f7042SNiels Sascha Reedijk
755338b8dc3SIngo Weinhold# create output directory
7566e7c6fe5SIngo Weinholdmkdir -p "$buildOutputDir" || exit 1
757338b8dc3SIngo Weinhold
7582ebcd86dSIngo Weinholdif [ "$HAIKU_HOST_BUILD_ONLY" = 1 ]; then
7592ebcd86dSIngo Weinhold	invalidCommand=$sourceDir/build/scripts/host_build_only
7602ebcd86dSIngo Weinhold	HAIKU_AR=$invalidCommand
7612ebcd86dSIngo Weinhold	HAIKU_CC=$invalidCommand
7622ebcd86dSIngo Weinhold	HAIKU_LD=$invalidCommand
7632ebcd86dSIngo Weinhold	HAIKU_OBJCOPY=$invalidCommand
7642ebcd86dSIngo Weinhold	HAIKU_RANLIB=$invalidCommand
7652ebcd86dSIngo Weinhold	HAIKU_ELFEDIT=$invalidCommand
766d6f80927SJonathan Schleifer	HAIKU_NASM=$invalidCommand
7672ebcd86dSIngo Weinhold	HAIKU_STRIP=$invalidCommand
7682ebcd86dSIngo Weinholdelse
769c0e8cc1aSIngo Weinhold	if [ -n "$HAIKU_PACKAGING_ARCHS" ]; then
770c0e8cc1aSIngo Weinhold		targetArchs="$HAIKU_PACKAGING_ARCHS"
771c0e8cc1aSIngo Weinhold	fi
772c0e8cc1aSIngo Weinhold	HAIKU_PACKAGING_ARCHS=
773c0e8cc1aSIngo Weinhold
774483b28e4SIngo Weinhold	# On Haiku determine target architectures and tools automatically.
775c0e8cc1aSIngo Weinhold	if [ -z "$targetArchs" ]; then
776483b28e4SIngo Weinhold		if [ $HOST_PLATFORM != haiku_host ]; then
777483b28e4SIngo Weinhold			echo "Please specify the build tools to use or build (via" \
778eaef83a9SJeroen Oortwijn				"--cross-tools-prefix or --build-cross-tools) or specify a" \
779483b28e4SIngo Weinhold				"host-only build (--host-only)." >&2
780483b28e4SIngo Weinhold			exit 1
781483b28e4SIngo Weinhold		fi
782483b28e4SIngo Weinhold
783483b28e4SIngo Weinhold		# determine primary architecture
784dda53eaeSIngo Weinhold		targetArch=`package list -i /system/packages/haiku-*.hpkg \
785483b28e4SIngo Weinhold			| sed '/^\s*architecture:/!d; s,^\s*architecture:\s*,,'`
786483b28e4SIngo Weinhold		is_in_list "$targetArch" "$supportedTargetArchs" || (
787483b28e4SIngo Weinhold			echo "Unsupported target architecture: \"$targetArch\"" >&2
788483b28e4SIngo Weinhold			exit 1
789483b28e4SIngo Weinhold		)
790c0e8cc1aSIngo Weinhold		targetArchs=$targetArch
791483b28e4SIngo Weinhold
792c0e8cc1aSIngo Weinhold		set_default_value HAIKU_AR_$targetArch			ar
793c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CC_$targetArch			gcc
794c0e8cc1aSIngo Weinhold		set_default_value HAIKU_LD_$targetArch			ld
795c0e8cc1aSIngo Weinhold		set_default_value HAIKU_OBJCOPY_$targetArch		objcopy
796c0e8cc1aSIngo Weinhold		set_default_value HAIKU_RANLIB_$targetArch		ranlib
797c0e8cc1aSIngo Weinhold		set_default_value HAIKU_ELFEDIT_$targetArch		elfedit
798c0e8cc1aSIngo Weinhold		set_default_value HAIKU_STRIP_$targetArch		strip
799483b28e4SIngo Weinhold
800483b28e4SIngo Weinhold		# determine secondary architectures
801483b28e4SIngo Weinhold		for targetArch in $supportedTargetArchs; do
80280262a91SMatt Madia			if [ -e /system/packages/haiku_$targetArch-*.hpkg ]; then
803483b28e4SIngo Weinhold				targetArchs="$targetArchs $targetArch"
804483b28e4SIngo Weinhold				set_default_value HAIKU_AR_$targetArch		ar-$targetArch
805483b28e4SIngo Weinhold				set_default_value HAIKU_CC_$targetArch		gcc-$targetArch
806483b28e4SIngo Weinhold				set_default_value HAIKU_LD_$targetArch		ld-$targetArch
807483b28e4SIngo Weinhold				set_default_value HAIKU_OBJCOPY_$targetArch	objcopy-$targetArch
808483b28e4SIngo Weinhold				set_default_value HAIKU_RANLIB_$targetArch	ranlib-$targetArch
809483b28e4SIngo Weinhold				set_default_value HAIKU_ELFEDIT_$targetArch	elfedit-$targetArch
810483b28e4SIngo Weinhold				set_default_value HAIKU_STRIP_$targetArch	strip-$targetArch
811483b28e4SIngo Weinhold			fi
812483b28e4SIngo Weinhold		done
813483b28e4SIngo Weinhold
814483b28e4SIngo Weinhold		# The target architectures might have been specified explicitly.
815483b28e4SIngo Weinhold		if [ -n "$haikuTargetArchs" ]; then
816483b28e4SIngo Weinhold			for targetArch in $haikuTargetArchs; do
817483b28e4SIngo Weinhold				is_in_list "$targetArch" "$targetArchs" || (
818483b28e4SIngo Weinhold					echo "Unsupported target architecture: \"$targetArch\"." \
819483b28e4SIngo Weinhold						"Only native architectures of the host platform can" \
820483b28e4SIngo Weinhold						"be specified." >&2
821483b28e4SIngo Weinhold					exit 1
822483b28e4SIngo Weinhold				)
823483b28e4SIngo Weinhold			done
824483b28e4SIngo Weinhold			targetArchs="$haikuTargetArchs"
825483b28e4SIngo Weinhold		fi
826c0e8cc1aSIngo Weinhold	fi
827c0e8cc1aSIngo Weinhold
82868ccc989SIngo Weinhold	isPrimaryArch=1
829c0e8cc1aSIngo Weinhold	for targetArch in $targetArchs; do
830c0e8cc1aSIngo Weinhold		# Note: targetArch is "unknown<n>" at this point, if a cross-tools
831c0e8cc1aSIngo Weinhold		# prefix was specified. The standard_gcc_settings call below will get
832c0e8cc1aSIngo Weinhold		# the actual architecture.
833c0e8cc1aSIngo Weinhold
834c0e8cc1aSIngo Weinhold		crossToolsPrefix=`get_variable crossToolsPrefix_$targetArch`
835c0e8cc1aSIngo Weinhold
836338b8dc3SIngo Weinhold		# build cross tools from sources
837c0e8cc1aSIngo Weinhold		if [ -n "$buildCrossTools" -a -z "$crossToolsPrefix" ]; then
838c0e8cc1aSIngo Weinhold			crossToolsDir="$outputDir/cross-tools-$targetArch"
839c0e8cc1aSIngo Weinhold			targetMachine=`get_variable buildCrossToolsMachine_$targetArch`
840c0e8cc1aSIngo Weinhold			script="$buildCrossToolsScript"
8418304ec7cSIngo Weinhold			scriptArgs=
842c0e8cc1aSIngo Weinhold			if [ $targetArch != x86_gcc2 ]; then
8438304ec7cSIngo Weinhold				script="${script}_gcc4"
8448304ec7cSIngo Weinhold				scriptArgs="$targetMachine"
8451e93288eSJérôme Duval				set_default_value HAIKU_USE_GCC_GRAPHITE_$targetArch	\
8461e93288eSJérôme Duval					$useGccGraphiteDefault
847c0e8cc1aSIngo Weinhold			fi
84868ccc989SIngo Weinhold			secondaryArch=
84968ccc989SIngo Weinhold			if [ -z "$isPrimaryArch" ]; then
85068ccc989SIngo Weinhold				secondaryArch=$targetArch
85168ccc989SIngo Weinhold			fi
85286de8c37SIngo Weinhold
85386de8c37SIngo Weinhold			case $HOST_PLATFORM in
85486de8c37SIngo Weinhold				freebsd|openbsd)	MAKE=gmake;;
85586de8c37SIngo Weinhold				*)					MAKE=make;;
85686de8c37SIngo Weinhold			esac
85786de8c37SIngo Weinhold
85886de8c37SIngo Weinhold			MAKE=$MAKE \
85968ccc989SIngo Weinhold			SECONDARY_ARCH=$secondaryArch \
860c0e8cc1aSIngo Weinhold			HAIKU_USE_GCC_GRAPHITE=`get_variable \
861c0e8cc1aSIngo Weinhold				HAIKU_USE_GCC_GRAPHITE_$targetArch` \
862b3ece905SJérôme Duval			HAIKU_USE_GCC_PIPE=$HAIKU_USE_GCC_PIPE \
8638304ec7cSIngo Weinhold			"$script" $scriptArgs "$sourceDir" "$buildCrossTools" \
8648304ec7cSIngo Weinhold				"$crossToolsDir" $buildCrossToolsJobs || exit 1
865c0e8cc1aSIngo Weinhold			crossToolsPrefix="$crossToolsDir/bin/${targetMachine}-"
866338b8dc3SIngo Weinhold		fi
867338b8dc3SIngo Weinhold
868c0e8cc1aSIngo Weinhold		# prepare gcc settings and get the actual target architecture
869c0e8cc1aSIngo Weinhold		gcc="${crossToolsPrefix}gcc"
870c0e8cc1aSIngo Weinhold		if [ -z "${crossToolsPrefix}" ]; then
871c0e8cc1aSIngo Weinhold			gcc=`get_variable HAIKU_CC_$targetArch`
872338b8dc3SIngo Weinhold		fi
873c0e8cc1aSIngo Weinhold		standard_gcc_settings "$gcc"
874c0e8cc1aSIngo Weinhold		targetArch=$standard_gcc_settings_targetArch
875338b8dc3SIngo Weinhold
876c0e8cc1aSIngo Weinhold		# set default values for flags
877c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CPPFLAGS_$targetArch	""
878c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CCFLAGS_$targetArch		""
879c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CXXFLAGS_$targetArch	""
880c0e8cc1aSIngo Weinhold		set_default_value HAIKU_LDFLAGS_$targetArch		""
881c0e8cc1aSIngo Weinhold		set_default_value HAIKU_ARFLAGS_$targetArch		cru
882c0e8cc1aSIngo Weinhold		set_default_value HAIKU_UNARFLAGS_$targetArch	x
883338b8dc3SIngo Weinhold
884c0e8cc1aSIngo Weinhold		# Override the cross tools variables, if the tools were built or a
885c0e8cc1aSIngo Weinhold		# prefix was specified.
886b7777272SAlex Smith		if [ -n "$crossToolsPrefix" ]; then
887c0e8cc1aSIngo Weinhold			get_build_tool_path AR_$targetArch ${crossToolsPrefix}ar
888c0e8cc1aSIngo Weinhold			get_build_tool_path LD_$targetArch ${crossToolsPrefix}ld
889c0e8cc1aSIngo Weinhold			get_build_tool_path OBJCOPY_$targetArch ${crossToolsPrefix}objcopy
890c0e8cc1aSIngo Weinhold			get_build_tool_path RANLIB_$targetArch ${crossToolsPrefix}ranlib
891c0e8cc1aSIngo Weinhold			get_build_tool_path STRIP_$targetArch ${crossToolsPrefix}strip
892c0e8cc1aSIngo Weinhold
893c0e8cc1aSIngo Weinhold			case `get_variable HAIKU_GCC_RAW_VERSION_$targetArch` in
894bd16f0ddSAlex Smith				4.*)
895c0e8cc1aSIngo Weinhold					get_build_tool_path ELFEDIT_$targetArch \
896c0e8cc1aSIngo Weinhold						${crossToolsPrefix}elfedit
897bd16f0ddSAlex Smith				;;
898bd16f0ddSAlex Smith			esac
89952a38012Sejakowatz		fi
90052a38012Sejakowatz
901c0e8cc1aSIngo Weinhold		# Get the libgcc objects. We couldn't do that in standard_gcc_settings,
902c0e8cc1aSIngo Weinhold		# since we need "ar", which may be set later.
903c0e8cc1aSIngo Weinhold		ar=`get_variable HAIKU_AR_$targetArch`
904c0e8cc1aSIngo Weinhold		libgcc=`get_variable HAIKU_GCC_LIBGCC_$targetArch`
905c0e8cc1aSIngo Weinhold		set_variable HAIKU_GCC_LIBGCC_OBJECTS_$targetArch \
906c0e8cc1aSIngo Weinhold			"`$ar t $libgcc | grep -v eabi.o`"
907c0e8cc1aSIngo Weinhold			# Note: We filter out eabi.o. It's present in gcc's libgcc for PPC
908c0e8cc1aSIngo Weinhold			# and neither needed nor wanted.
909c0e8cc1aSIngo Weinhold
910ef57df3dSIngo Weinhold		# check whether the Haiku compiler really targets Haiku
911c0e8cc1aSIngo Weinhold		targetMachine=`get_variable HAIKU_GCC_MACHINE_$targetArch`
912c0e8cc1aSIngo Weinhold		case "$targetMachine" in
913eedc3d0bSIngo Weinhold			*-*-haiku)	;;
914c0e8cc1aSIngo Weinhold			*)
915c0e8cc1aSIngo Weinhold				echo The compiler specified as Haiku target compiler is not a \
916c0e8cc1aSIngo Weinhold				valid Haiku cross-compiler. Please see ReadMe.cross-compile. >&2
917eedc3d0bSIngo Weinhold				echo compiler: $HAIKU_CC
918c0e8cc1aSIngo Weinhold				echo compiler is configured for target: $targetMachine
919eedc3d0bSIngo Weinhold				exit 1 ;;
920eedc3d0bSIngo Weinhold		esac
921c0e8cc1aSIngo Weinhold
922c0e8cc1aSIngo Weinhold		HAIKU_PACKAGING_ARCHS="$HAIKU_PACKAGING_ARCHS $targetArch"
92368ccc989SIngo Weinhold		isPrimaryArch=
924c0e8cc1aSIngo Weinhold	done
9252ebcd86dSIngo Weinholdfi
926eedc3d0bSIngo Weinhold
92752a38012Sejakowatz# Generate BuildConfig
9287c4641d0SOliver Tappecat << EOF > "$buildConfigFile"
92952a38012Sejakowatz# BuildConfig
930ab2540c4SIngo Weinhold# Note: This file has been automatically generated by configure with the
931ab2540c4SIngo Weinhold# following arguments:
93255d267a4SFrançois Revol# ${configureArgs}
93352a38012Sejakowatz
9347c4641d0SOliver TappeTARGET_PLATFORM 			?= "${TARGET_PLATFORM}" ;
9357c4641d0SOliver TappeHOST_PLATFORM				?= "${HOST_PLATFORM}" ;
936338b8dc3SIngo Weinhold
9377c4641d0SOliver TappeHAIKU_INCLUDE_GPL_ADDONS			?= "${HAIKU_INCLUDE_GPL_ADDONS}" ;
9387c4641d0SOliver TappeHAIKU_INCLUDE_PATENTED_CODE			?= "${HAIKU_INCLUDE_PATENTED_CODE}" ;
93976fa0be3SIngo WeinholdHAIKU_INCLUDE_SOURCES				?= "${HAIKU_INCLUDE_SOURCES}" ;
9407c4641d0SOliver TappeHAIKU_INCLUDE_3RDPARTY				?= "${HAIKU_INCLUDE_3RDPARTY}" ;
9417c4641d0SOliver TappeHAIKU_ENABLE_MULTIUSER				?= "${HAIKU_ENABLE_MULTIUSER}" ;
9427c4641d0SOliver TappeHAIKU_DISTRO_COMPATIBILITY			?= "${HAIKU_DISTRO_COMPATIBILITY}" ;
9437c4641d0SOliver TappeHAIKU_USE_GCC_PIPE					?= "${HAIKU_USE_GCC_PIPE}" ;
9447986925fSIngo WeinholdHAIKU_HOST_USE_32BIT				?= "${HAIKU_HOST_USE_32BIT}" ;
9457986925fSIngo WeinholdHAIKU_HOST_USE_XATTR				?= "${HAIKU_HOST_USE_XATTR}" ;
946bc96e8f3SIngo WeinholdHAIKU_HOST_USE_XATTR_REF			?= "${HAIKU_HOST_USE_XATTR_REF}" ;
9472ebcd86dSIngo WeinholdHAIKU_HOST_BUILD_ONLY				?= "${HAIKU_HOST_BUILD_ONLY}" ;
948eccc7665SIngo Weinhold
949c0e8cc1aSIngo WeinholdHAIKU_PACKAGING_ARCHS		?= ${HAIKU_PACKAGING_ARCHS} ;
95065ad1ba3SAlex Smith
951*aa2e5ecaSOliver TappeHAIKU_NO_DOWNLOADS			?= "${HAIKU_NO_DOWNLOADS}" ;
952*aa2e5ecaSOliver Tappe
9537c4641d0SOliver TappeHAIKU_BUILD_ATTRIBUTES_DIR	?= ${HAIKU_BUILD_ATTRIBUTES_DIR} ;
954338b8dc3SIngo Weinhold
955d6f80927SJonathan SchleiferHAIKU_NASM					?= ${HAIKU_NASM} ;
956e70c4c64SPulkoMandyHAIKU_BOOT_BOARD			?= ${HAIKU_BOOT_BOARD} ;
957338b8dc3SIngo Weinhold
958f04f7042SNiels Sascha ReedijkHOST_EXTENDED_REGEX_SED		?= ${HOST_EXTENDED_REGEX_SED} ;
9597c4641d0SOliver TappeHOST_GCC_RAW_VERSION		?= ${HOST_GCC_RAW_VERSION} ;
9607c4641d0SOliver TappeHOST_GCC_MACHINE			?= ${HOST_GCC_MACHINE} ;
9617c4641d0SOliver TappeHOST_LD						?= ${HOST_GCC_LD} ;
9627c4641d0SOliver TappeHOST_OBJCOPY				?= ${HOST_GCC_OBJCOPY} ;
963c505b276SFrançois RevolHOST_SFDISK					?= ${HOST_SFDISK} ;
9642a5d0aafSIngo WeinholdHOST_SHA256					?= ${HOST_SHA256} ;
9658b5934c9SIngo Weinhold
966e173a1ecSIngo WeinholdHOST_HAIKU_PORTER			?= ${HOST_HAIKU_PORTER} ;
967e173a1ecSIngo WeinholdHAIKU_PORTS					?= ${HAIKU_PORTS} ;
968e173a1ecSIngo WeinholdHAIKU_PORTS_CROSS			?= ${HAIKU_PORTS_CROSS} ;
969e173a1ecSIngo Weinhold
970c4786ea6SlilloEOF
971c4786ea6Slillo
972c0e8cc1aSIngo Weinholdfor targetArch in $HAIKU_PACKAGING_ARCHS; do
973c0e8cc1aSIngo Weinhold	variables="
974c0e8cc1aSIngo Weinhold		HAIKU_GCC_RAW_VERSION		HAIKU_GCC_RAW_VERSION
975c0e8cc1aSIngo Weinhold		HAIKU_GCC_MACHINE			HAIKU_GCC_MACHINE
976c0e8cc1aSIngo Weinhold		HAIKU_GCC_LIB_DIR			HAIKU_GCC_LIB_DIR
977c0e8cc1aSIngo Weinhold		HAIKU_GCC_LIBGCC			HAIKU_GCC_LIBGCC
978c0e8cc1aSIngo Weinhold		HAIKU_CPU					HAIKU_CPU
979c0e8cc1aSIngo Weinhold		HAIKU_STATIC_LIBSTDC++		HAIKU_STATIC_LIBSTDCXX
980c0e8cc1aSIngo Weinhold		HAIKU_SHARED_LIBSTDC++		HAIKU_SHARED_LIBSTDCXX
981c0e8cc1aSIngo Weinhold		HAIKU_STATIC_LIBSUPC++		HAIKU_STATIC_LIBSUPCXX
982c0e8cc1aSIngo Weinhold		HAIKU_SHARED_LIBSUPC++		HAIKU_SHARED_LIBSUPCXX
983c0e8cc1aSIngo Weinhold		HAIKU_KERNEL_LIBGCC			HAIKU_KERNEL_LIBGCC
984c0e8cc1aSIngo Weinhold		HAIKU_KERNEL_LIBSUPC++		HAIKU_KERNEL_LIBSUPCXX
985c0e8cc1aSIngo Weinhold		HAIKU_BOOT_LIBGCC			HAIKU_BOOT_LIBGCC
986c0e8cc1aSIngo Weinhold		HAIKU_BOOT_LIBSUPC++		HAIKU_BOOT_LIBSUPCXX
987c0e8cc1aSIngo Weinhold		HAIKU_AR					HAIKU_AR
988c0e8cc1aSIngo Weinhold		HAIKU_CC					HAIKU_CC
989c2b76f7fSJonathan Schleifer		HAIKU_CC_IS_CLANG			HAIKU_CC_IS_CLANG
990c0e8cc1aSIngo Weinhold		HAIKU_LD					HAIKU_LD
991c0e8cc1aSIngo Weinhold		HAIKU_OBJCOPY				HAIKU_OBJCOPY
992c0e8cc1aSIngo Weinhold		HAIKU_RANLIB				HAIKU_RANLIB
993c0e8cc1aSIngo Weinhold		HAIKU_ELFEDIT				HAIKU_ELFEDIT
994c0e8cc1aSIngo Weinhold		HAIKU_STRIP					HAIKU_STRIP
995c0e8cc1aSIngo Weinhold		HAIKU_CPPFLAGS				HAIKU_CPPFLAGS
996c0e8cc1aSIngo Weinhold		HAIKU_CCFLAGS				HAIKU_CCFLAGS
997c0e8cc1aSIngo Weinhold		HAIKU_C++FLAGS				HAIKU_CXXFLAGS
998c0e8cc1aSIngo Weinhold		HAIKU_LDFLAGS				HAIKU_LDFLAGS
999c0e8cc1aSIngo Weinhold		HAIKU_ARFLAGS				HAIKU_ARFLAGS
1000c0e8cc1aSIngo Weinhold		HAIKU_UNARFLAGS				HAIKU_UNARFLAGS
1001c0e8cc1aSIngo Weinhold		HAIKU_USE_GCC_GRAPHITE		HAIKU_USE_GCC_GRAPHITE
1002c0e8cc1aSIngo Weinhold		"
1003c0e8cc1aSIngo Weinhold	set -- $variables
1004c0e8cc1aSIngo Weinhold	while [ $# -ge 2 ]; do
1005c0e8cc1aSIngo Weinhold		value=`get_variable ${2}_$targetArch`
1006c0e8cc1aSIngo Weinhold		echo "${1}_${targetArch} ?= $value ;" >> "$buildConfigFile"
1007c0e8cc1aSIngo Weinhold		shift 2
1008c0e8cc1aSIngo Weinhold	done
1009b1e5b60cSAxel Dörfler
1010c0e8cc1aSIngo Weinhold	# For variables that may have long values, distribute them over multiple
1011c0e8cc1aSIngo Weinhold	# lines so that jam doesn't hit the maximum line length.
1012c0e8cc1aSIngo Weinhold	variables="
1013c0e8cc1aSIngo Weinhold		HAIKU_GCC_HEADERS_DIR		HAIKU_GCC_HEADERS_DIR
1014c0e8cc1aSIngo Weinhold		HAIKU_C++_HEADERS_DIR		HAIKU_CXX_HEADERS_DIR
101566a7f29fSJérôme Duval		HAIKU_BOOT_C++_HEADERS_DIR	HAIKU_BOOT_CXX_HEADERS_DIR
1016c0e8cc1aSIngo Weinhold		HAIKU_GCC_LIBGCC_OBJECTS	HAIKU_GCC_LIBGCC_OBJECTS
1017c0e8cc1aSIngo Weinhold		"
1018c0e8cc1aSIngo Weinhold	set -- $variables
1019c0e8cc1aSIngo Weinhold	while [ $# -ge 2 ]; do
1020c0e8cc1aSIngo Weinhold		echo "${1}_${targetArch} ?= " >> "$buildConfigFile"
1021c0e8cc1aSIngo Weinhold		get_variable ${2}_$targetArch | xargs -n 1 echo "   " \
1022c0e8cc1aSIngo Weinhold			>> "$buildConfigFile"
1023c0e8cc1aSIngo Weinhold		echo "    ;" >> "$buildConfigFile"
1024c0e8cc1aSIngo Weinhold		shift 2
1025c0e8cc1aSIngo Weinhold	done
1026c0e8cc1aSIngo Weinholddone
1027b1e5b60cSAxel Dörfler
1028b1e5b60cSAxel Dörfler
10299b0dd528SIngo Weinhold# Generate a boot strap Jamfile in the output directory.
1030338b8dc3SIngo Weinhold
1031338b8dc3SIngo Weinholdcat << EOF > $outputDir/Jamfile
1032338b8dc3SIngo Weinhold# automatically generated Jamfile
1033338b8dc3SIngo Weinhold
1034338b8dc3SIngo WeinholdHAIKU_TOP			= ${sourceDir} ;
1035338b8dc3SIngo WeinholdHAIKU_OUTPUT_DIR	= ${outputDir} ;
1036338b8dc3SIngo Weinhold
1037338b8dc3SIngo Weinholdinclude [ FDirName \$(HAIKU_TOP) Jamfile ] ;
1038338b8dc3SIngo Weinhold
1039338b8dc3SIngo WeinholdEOF
1040